//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tysd.com"
#property link       "www.forex-tysd.com"
#property indicator_chart_window
#property indicator_buffers 0

extern int   Days                = 10;
extern bool  SkipSunday          = true;
extern bool  PivotsVisible       = true;
extern color PivotsColor         = DimGray;
extern color PivotsUpColor       = DeepSkyBlue;
extern color PivotsDnColor       = Red;
extern int   PivotsStyle         = STYLE_SOLID;
extern int   PivotsWidth         = 1;
extern bool  PivotsMiddleVisible = false;
extern color PivotsMiddleUpColor = DeepSkyBlue;
extern color PivotsMiddleDnColor = Red;
extern int   PivotsMiddleStyle   = STYLE_DOT;
extern int   PivotsMiddleWidth   = 1;
extern bool  CammarilaVisible    = false;
extern color CammarilaColor      = Gold;
extern int   CammarilaStyle      = STYLE_SOLID;
extern int   CammarilaWidth      = 1;

//
//
//
//
//

double   YesterdayHigh[];
double   YesterdayLow[];
double   YesterdayClose[];
datetime YesterdayTime[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   ArrayCopySeries(YesterdayHigh,  MODE_HIGH,  Symbol(), PERIOD_D1);
   ArrayCopySeries(YesterdayLow,   MODE_LOW,   Symbol(), PERIOD_D1);
   ArrayCopySeries(YesterdayClose, MODE_CLOSE, Symbol(), PERIOD_D1);
   ArrayCopySeries(YesterdayTime,  MODE_TIME,  Symbol(), PERIOD_D1);
   return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = "pivotAll:";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--) 
   {
      string name = ObjectName(i);  if (StringSubstr(name,0,lookForLength) == lookFor) ObjectDelete(name);
   }
   return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   if (Period()>PERIOD_D1) return(0);
   int limit=MathMin(Bars-1,iBarShift(NULL,0,iTime(NULL,PERIOD_D1,Days)));
   int count=0;

      //
      //
      //
      //
      //
      
      for(int i = limit; i>=0; i--) 
      {
         if(TimeDay(Time[i]) != TimeDay(Time[i+1])) 
         {
            int y = iBarShift(NULL,PERIOD_D1,Time[i+1]); if (SkipSunday && TimeDayOfWeek(YesterdayTime[y])==0) y++;
           
              double Pivot = (YesterdayHigh[y] + YesterdayLow[y] + YesterdayClose[y]) / 3.0;
              double R1 = (2.0*Pivot) - YesterdayLow[y]; 
              double S1 = (2.0*Pivot) - YesterdayHigh[y];
              double R2 = Pivot + (YesterdayHigh[y] - YesterdayLow[y]);
              double S2 = Pivot - (YesterdayHigh[y] - YesterdayLow[y]);
              double R3 = Pivot*2.0 + (YesterdayHigh[y] - YesterdayLow[y]*2.0);
              double S3 = Pivot*2.0 - (YesterdayHigh[y]*2.0 - YesterdayLow[y]);
               
               //
               //
               //
               //
               //
               
               if (PivotsVisible)
               {
                  drawLine("P" ,count,Pivot,PivotsColor  ,PivotsStyle,PivotsWidth,i);
                  drawLine("R1",count,R1   ,PivotsUpColor,PivotsStyle,PivotsWidth,i);
                  drawLine("R2",count,R2   ,PivotsUpColor,PivotsStyle,PivotsWidth,i);
                  drawLine("R3",count,R3   ,PivotsUpColor,PivotsStyle,PivotsWidth,i);
                  drawLine("S1",count,S1   ,PivotsDnColor,PivotsStyle,PivotsWidth,i);
                  drawLine("S2",count,S2   ,PivotsDnColor,PivotsStyle,PivotsWidth,i);
                  drawLine("S3",count,S3   ,PivotsDnColor,PivotsStyle,PivotsWidth,i);
               }       
               if (PivotsMiddleVisible)
               {
                  drawLine("M1",count,(Pivot+R1)/2.0,PivotsMiddleUpColor,PivotsMiddleStyle,PivotsMiddleWidth,i);
                  drawLine("M2",count,(R1   +R2)/2.0,PivotsMiddleUpColor,PivotsMiddleStyle,PivotsMiddleWidth,i);
                  drawLine("M3",count,(R2   +R3)/2.0,PivotsMiddleUpColor,PivotsMiddleStyle,PivotsMiddleWidth,i);
                  drawLine("M4",count,(Pivot+S1)/2.0,PivotsMiddleDnColor,PivotsMiddleStyle,PivotsMiddleWidth,i);
                  drawLine("M5",count,(S1   +S2)/2.0,PivotsMiddleDnColor,PivotsMiddleStyle,PivotsMiddleWidth,i);
                  drawLine("M6",count,(S2   +S3)/2.0,PivotsMiddleDnColor,PivotsMiddleStyle,PivotsMiddleWidth,i);
               }
               if (CammarilaVisible)
               {
                  double close = YesterdayClose[y];
                  double Range = YesterdayHigh[y] - YesterdayLow[y];
                  double H4 = close + (Range * 1.1/2.0);
                  double H3 = close + (Range * 1.1/4.0);
                  double H2 = close + (Range * 1.1/6.0);
                  double H1 = close + (Range * 1.1/12.0);
                  double L1 = close - (Range * 1.1/12.0);
                  double L2 = close - (Range * 1.1/6.0);
                  double L3 = close - (Range * 1.1/4.0);
                  double L4 = close - (Range * 1.1/2.0);
                     drawLine("H1",count,H1,CammarilaColor,CammarilaStyle,CammarilaWidth,i);
                     drawLine("H2",count,H2,CammarilaColor,CammarilaStyle,CammarilaWidth,i);
                     drawLine("H3",count,H3,CammarilaColor,CammarilaStyle,CammarilaWidth,i);
                     drawLine("H4",count,H4,CammarilaColor,CammarilaStyle,CammarilaWidth,i);
                     drawLine("L4",count,L4,CammarilaColor,CammarilaStyle,CammarilaWidth,i);
                     drawLine("L3",count,L3,CammarilaColor,CammarilaStyle,CammarilaWidth,i);
                     drawLine("L2",count,L2,CammarilaColor,CammarilaStyle,CammarilaWidth,i);
                     drawLine("L1",count,L1,CammarilaColor,CammarilaStyle,CammarilaWidth,i);
               }
               count++;
         }
     }
   return(0);
}

//
//
//
//
//

void drawLine(string name, string add, double value, double line_color, double style,int width, int i)
{
   datetime time1 = iTime(NULL,PERIOD_D1,iBarShift(NULL,PERIOD_D1,Time[i]));
   datetime time2 = time1+PERIOD_D1*60;  
      name = "pivotAll:"+name+":"+add;
      ObjectCreate(name,OBJ_TREND,0,0,0,0,0);
         ObjectSet(name,OBJPROP_TIME1,  time1);
         ObjectSet(name,OBJPROP_TIME2,  time2);
         ObjectSet(name,OBJPROP_PRICE1, value);
         ObjectSet(name,OBJPROP_PRICE2, value);
         ObjectSet(name,OBJPROP_STYLE,  style);
         ObjectSet(name,OBJPROP_WIDTH,  width);
         ObjectSet(name,OBJPROP_RAY,    false);
         ObjectSet(name,OBJPROP_BACK,   true);
         ObjectSet(name,OBJPROP_COLOR,  line_color);
}        

